#ifndef __FFT_H
#define __FFT_H
//--------------------------------------------------------
//FFT class library
//--------------------------------------------------------
#include <math.h>
#include  "vecmath.h"
//--------------------------------------------------------
#define PI     3.1415926535897932384626433832795028841971
//--------------------------------------------------------
// ƣƣԶ
// FFT(10) ۼѴ
// ʹ Vecmath   ó  ִ ABS=abs(src) 
//--------------------------------------------------------
class FFT
{
  private:
  int FFT_BIT;
  int FFT_N; // 2^Bit
  double  *sin_d, *cos_d, *Mask_d;

  public:
  Vec2<double> *src;
  enum  MaskTag  {
   MDoNothing, MTriangle, MSine, MHunning,   MHumming
  }   Mask;

  FFT(int Bit);
  ~FFT();

  int GetFFT_N(void)   { return   FFT_N;   }
  void  init(void);
  void  bit_rev(void);
  double sinf(int n)  {  return sin_d[n];  }
  double cosf(int n)  { return cos_d[n];  }
  void   SetIntData(int   *);
  void   GetIntData(int   *);
  void  fft_cnv(void);

  //ƣƣ , ߧ¡𣱣
  //Window Mask               3dB뿪 Ĵ ִ밪   DC    harm @FFT_N=64
  void   DoNothing(void);    // 0.89/T -13dB â   64    32
  void   Triangle(void);     //  1.25/T -26dB          32    16
  void   Sine(void);         //  1.17/T -23dB          40.73 20.41
  void   Hunning(void);      //  1.44/T -32dB          34.56 17.28
  void   Humming(void);      //  1.36/T -42dB          32    16
  void   MaskExe(void);      //ũ Ǵ

  void  Kikaku(void);  //   ͷ ģãúκк ԰ȭ
  void  GetDBCnv(int *p,  int Dot10, int Zero=1000);  //dB ȯϿ ´
};
//--------------------------------------------------------
//--------------------------------------------------------
#endif   //__FFT_H

