#ifndef  __GidADC_H
#define  __GidADC_H
//====================================================================
// Gid-ADC interface 16/32bitMode ͪϼ 1997/5/5
//====================================================================
#pragma hdrstop
#include  <bios.h>
/*==============================================*/
//Win32   
//io32.cpp ܺο ʿ ϹǷ tasm32.exe ʿ Ѵ
//ſ io32.obj ũص 
#ifdef  __WIN32__
#include  "io32.h"
#endif  //__WIN32__
/*==============================================*/
/*    */
#define PCAT
//#define PC98
/*==============================================*/
/* PCAT ϵ */
#ifdef PCAT
  #define COM1_BASE     0x3f8
  #define COM2_BASE     0x2f8
  #define COM3_BASE     0x3e8
  #define COM4_BASE     0x2e8
  #define SIO_MDM       4       /* rw modem control */
  #define SIO_MDM_RTS   0x02    /* RTS */
  #define SIO_MDM_DTR   0x01    /* DTR */
  #define SIO_MSR       6       /* rw modem status */
  #define SIO_MDMS_RLSD 0x80    /* RLSD */
  #define SIO_LCR       3       /* rw line contorlo */
  #define SIO_BRK       0x40    /*  break data send                      */
#endif /* PCAT */
/*------------------------*/
#ifdef  PC98
  #define SIO_RES 0x40          /*  Ŀǵ */
  #define SIO_8N 0x4e            /* 8bit non parity 16clk */

  /* 8251 command */
  #define SIO_TX_EN 0x01    /*  0=۽ű 1=۽㰡                */
  #define SIO_DTR   0x02    /*   ģԣ                        */
  #define SIO_RX_EN 0x04    /*  0=ű  1=㰡               */
  #define SIO_BRK   0x08    /*  0= 1=극ũ(۽Ż£)      */
  #define SIO_ECL   0x10    /*  0=nop 1= ÷            */
  #define SIO_RTS   0x20    /*   ңԣ                        */
  #define SIO_SRES  0x40    /*  0=nop 1=                          */
  #define SIO_EH    0x80    /*  0=nop 1=ڵ         */

  /* 8251 status  */
  #define SIO_TX_RDY   0x01    /*  0=۽ Ǯ 1=                 */
  #define SIO_RX_RDY   0x02    /*  0=   1=ŵ  */
  #define SIO_TX_EMP   0x04    /*  0=۽   1=۽ ƴ */
  #define SIO_PE       0x08    /*  0=иƼ   1=             */
  #define SIO_OVE      0x10    /*  0=   1=             */
  #define SIO_FE       0x20    /*  0=÷   1=             */
  #define SIO_SYNC_BRK 0x40    /*  0/1=극ũ                      */
  #define SIO_DSR      0x80    /*   DSR                      */

  /*; 8251a      2-12-1*/
  #define SIOD 0x30
  #define SIOC 0x32
  #define PPI1B 0x33        /*
  ;     pb0     calender read line
  ;     pb1     external ram parity error detecter
  ;     pb2     none
  ;     pb3     crt type 1=high, 0=normal
  ;     pb4     int3(HD)
  ;     pb5     CD carrier detect(negative)
  ;     pb6     CTS (negative)
  ;     pb7     CI (rs232c ?) */
  #define DSR_MASK 0x10  /* 8251 MSB ⿡  ´ */
  #define CD_MASK 0x20
  #define CTS_MASK 0x40
  #define CI_MASK 0x80

#endif  /* for PC98 */

//================================================
class GidADC
{
  private:
  int Comport;  //RS232C COM Ʈ ȣ 14(PCAT) 1(PC98)

  #define UNIPOLA 0x08
  #define BIPOLA  0
  int Pola;     //Ƴα ȯ  UNIPOLA=04095mV BIPOLA=2047mV
  int Ch;       //Ƴα Է ä 07

  #define Diff  0
  #define Singl 0x04
  int SglDif;     //Ƴα Է  Diff=Է Single= Է

  //GetNTCnv() Ʈ 
  int TrigaPola;  //1= , -1=翡 
  int TrigaAuto;  //0=none, 1=Auto2=Normal

  int    CliMode;    // ȯ  ͷƮ ϴ ÷

  int TxStat;     //Tx  
  #ifdef  PC98
  unsigned char ComMem; //Tx    PC98 ȴ
  #endif

  public:
  GidADC(void)  { Init(); }   //ܽƮ,  ޸ ̴ϼȸ

  // ʱȭ, ܽƮͷ ȣǹǷ  ȣ ʿ䰡 
  void  Init(void);

  //ȣ ϰ  ϴ Ʈ ȣ 1 ϴ ȣ
  void  InitPower(int  ComNum);

  void  SetCh(int ch);  //Ƴα Է ä ȣ(07)   Ѵ

  //ȯ  
  void  SetUnipola(void){ Pola = UNIPOLA; } //04095mV
  void  SetBipola(void) { Pola = BIPOLA;  } //2047mV
  void  SetSingle(void) { SglDif = Singl; } //
  void  SetDiff(void)   { SglDif = Diff;  } //

  //Ʈ   ϸ忡  ȯϴ 쿡 ȴ
  enum  { TNone, TAuto, TNormal };
  void  SetTrigaNone(void)  { TrigaAuto = TNone;  } //Ʈ 
  void  SetTrigaAuto(void)  { TrigaAuto = TAuto;  } //ڵ
  void  SetTrigaNormal(void){ TrigaAuto = TNormal;} //ƮŰ ֱ 
  void  SetTrigaPlus(void)  { TrigaPola = 1;  }     //ؼ
  void  SetTrigaMinus(void) { TrigaPola = -1; }     //ؼ

  //Ÿ̹  Ŭ, Ʈκ, 1͸  ȸ 
  void  SetClkWait(long t)  { ClkW = t;   if(ClkW <=0) ClkW=1;}
  long  GetClkWait(void)    { return  ClkW; }
  void  SetStbWait(long t)  { StbW = t;   if(StbW <=0) StbW=1;}
  long  GetStbWait(void)    { return  StbW; }
  void  SetBlkWait(long t)  { BlkW = t;   if(BlkW <=0) BlkW=1;}
  long  GetBlkWait(void)    { return  BlkW; }

  //Ʈ Ʈ
   void  SetTx(int i);       //Tx Ʈ(1/0) Ѵ
  void  SetTxPulse(long t); //ð(Уǰ)ŭԣȣ  Ѵ

  // Ǿ ִ Ƴα ä о鼭 data ʰϱ Tx 1
  //Ѵ.  ʰϸ 0 ش. ó  Ͽ ϹǷ
  //޽  ʴ 쵵 ִ.

  void  GidADC::SetTxPulseWait(int d);

  //1  

  int   GetCnv(void);

  //   n ͸ Ѵ

  int  GetNCnv(int  n,  int *buf);

  //  , Ʈ 
  //wn n 踦  2̸ 2, ڵ̸  ŭ ƮŸ ٸ
  //ȯ μ ̸ ,  ̸̿ ƮŰ  ʹ 
  //ȯ ͷƮ SetCliMode() Ѵ
  int  GetNTCnv(int  v,  int n,  int wn,  int *buf);

  //PC ý ͷƮ GetNCnv() GetNTCnv() Ͽ ϴ 
  //ٸ 忡  ʴ´
  // ϸ  氣 Ȯ , ۿ PC ð
  //PC ð ǰ, ð  ⵿ϸ  ư.
  void  SetCliMode(int i = 1)    {       CliMode = i;    } //μ  CLI 
  void  ReSetCliMode(void)      {       CliMode = 0;    } //

  //μ
  //GetN(T)Cnv 1ʹ ð ʴ Ѵ
  double  GetNCnvTime(void);  // 
  double  NCnvTime;           // ϰ Ƿ ߿ о  ִ

  // Ʒ 
  private:
  long  ClkW;         //Ŭ                     ġ=1
  long  StbW;         //Ʈκ                 ġ=1
  long  BlkW;         //GetN(T)Cnv Ͱ     ġ=1
  void  ClkWait(void);
  void  StbWait(void);
  void  BlkWait(void);
  void  SCLK(int  Dout);    //DATA out Only CLK
  int   SCLKD(void);        // о CLK
  int   DOut(int Command);  //1bit DOUT
  void  SetTxE(void);       //Txe Ʈ Ʈ
  void  SetComport(int  c); // ϴ COM Ʈ ȣ
};
//===============================================
#endif  /*   __GidADC_H */

