PROGRAM kiatsuk ; (*   2000 / 9 / 28  C.C.ZE-QUE M.Nakano *)
(* AD7707 DATA MSB 1st. Clock and CS are Normaly Hi.
  Data-IN must be stable at lo to hi transition of SCLK. *)

CONST 
  paraports = $40 ; paraporto = 8 ;(* Pararel port base *)
  cr=^m^j ;
  maxwait=1500 ; (* Max time wait for DRDY *)
VAR cc : CHAR ;        erf : BOOLEAN ;
  st : STRING[80] ;
  pdat,pstat,pcont,prtno : WORD ;
  gant : ARRAY[0..3]OF WORD;(* Gain table *)
  modt : ARRAY[0..3]OF BOOLEAN ;(* Mode table. TRUE=Unipola mode *)
  nda,srat,chs,rbf,nbf,cnt : WORD ;

FUNCTION keyprs:BOOLEAN; Assembler; ASM MOV AH,11 ; INT 33 ; NEG AL ;RET END ;
FUNCTION getchar : CHAR ; Assembler ; ASM  MOV AH,8  ; INT 33 ; RET END ;
PROCEDURE dela(t : WORD) ; BEGIN FOR t:=t DOWNTO 0 DO END ;
PROCEDURE Delay(t : WORD) ; VAR i,j:LONGINT ;
  BEGIN i:=t ; FOR j:=i * 1000 DOWNTO 0 DO END ;

Procedure ot(dd : BYTE) ; BEGIN PORT[pcont]:=dd END ;
FUNCTION rdy : BOOLEAN ; BEGIN rdy:=PORT[pstat] > 127 END ;
FUNCTION inda : BOOLEAN ; BEGIN inda:=(PORT[pstat] AND 64) <>0  END ;
PROCEDURE ot8(dd : BYTE) ; VAR i : WORD ; BEGIN ot(12) ; FOR i:=0 TO 7 DO
  BEGIN IF dd>127 THEN BEGIN ot(13) ; dela(50) ; ot(12) END
        ELSE BEGIN ot(15) ; dela(50) ; ot(14) END ;
    dd:=dd SHL 1 ; dela(150) END ; ot(4) END ;
PROCEDURE ot24(dd : LONGINT) ; VAR i : WORD ; BEGIN ot(12) ; FOR i:=0 TO 23 DO
  BEGIN IF (dd AND $800000)>0 THEN BEGIN ot(13) ; dela(50) ; ot(12) END
        ELSE BEGIN ot(15) ; dela(50) ; ot(14) END ;
    dd:=dd SHL 1 ; dela(150) END ; ot(4) END ;
PROCEDURE otr(rr,dd : BYTE ) ;
  BEGIN ot8((rr SHL 4)+(chs AND 3)) ; Delay(2) ; ot8(dd) ; Delay(2) END ;
PROCEDURE otr24(rr : BYTE ; dd : LONGINT) ;
  BEGIN ot8((rr SHL 4)+(chs AND 3)) ; Delay(2) ; ot24(dd) ; Delay(2) END ;
FUNCTION in16(dd : WORD) : WORD ; VAR i,j : WORD ;
  BEGIN ot8($30+8+(dd AND 3)) ; j:=0 ; ot(12) ;
  FOR i:=0 TO 15 DO BEGIN ot(13) ; dela(50) ; ot(12); j:=j SHL 1;
      IF inda THEN Inc(j) ; dela(150) END;
  ot(4) ; in16:=j ; dela(300) END ;
FUNCTION inr8(rr : WORD) : LONGINT ; VAR i : WORD ; j : LONGINT ;
  CONST ltb:ARRAY[0..7]OF WORD=(8,8,8,16,8,0,24,24) ;
  BEGIN IF rr=5 THEN BEGIN WRITELN('No regi 5') ; EXIT END ;
  ot8((rr SHL 4)+8+(chs AND 3)) ; j:=0 ; ot(12) ;
  FOR i:=1 TO ltb[rr] DO BEGIN ot(13) ; dela(50) ; ot(12); j:=j SHL 1;
      IF inda THEN Inc(j) ; dela(150) END;
  ot(4) ; inr8:=j ; dela(300) END ;
PROCEDURE cali(ch : WORD) ;(* Calibrate Input ch *) VAR i : LONGINT ;
  BEGIN otr(1,$40+gant[ch] SHL 3+Ord(modt[ch]) SHL 2) ;
    Delay(100) ; i:=0 ;
    REPEAT Inc(i) ; Delay(10) UNTIL rdy OR keyprs OR (i > maxwait ) ;
    IF i>maxwait THEN erf:=TRUE ;
    IF erf THEN WRITELN('Time Over for DRDY',#7)
    END ;
PROCEDURE cala ; (* Calibrate All channels *)
  BEGIN cali(0) ; cali(1) ; cali(3) END ;
PROCEDURE iniad ;(* Initialize AD7707 *) BEGIN
  PORT[pdat]:=$FF ; ot(0) ; Delay(100) (* Reset AD7707 *) ; ot(4) ;
  END ;
PROCEDURE dispara ; VAR i : WORD ; BEGIN
  WRITELN('Selected Ch',chs,'    SamplingRate code=',srat,'    TimeOver=',er
f);
  FOR i:=0 TO 3 DO WRITELN('Ch',i,'  Gain=',gant[i],'   Unipola=',modt[i])
  END ;

PROCEDURE dishelp ; BEGIN WRITELN('AD7707 test command',cr,
'B : set Bipola mode (selected chann).',cr,
'C : Calibrate Input N. 0..3',cr,
'E : Enter Register N V.',cr,
'G : Gain setting. Gain code 0..7.   Automatic calibrate selected chann',cr,
'I : Initialize ADC and Reset Error.',cr,
'R : Sampling Rate.  sampl rate code 0..15.',cr,
'S : Select Input. 0..3.',cr,
'T : Read Register N. 0..7',cr,
'U : set Unipola mode (selected chann).',cr,
'/ : Display parameters',cr,
'? : Display Help(This command)',cr,
'Q,<ESC>: Quit to DOS') END ;

(* MAIN *)
BEGIN prtno:=0 ; IF ParamCount>0 THEN BEGIN st:=ParamStr(1) ; cc:=st[1] ;
  IF (cc IN['0'..'2']) AND (Length(st)=1) THEN prtno:=Byte(cc) AND 3
  ELSE BEGIN WRITELN(
  'How To Use AD7707 Barometer PROGRAM.C.C.ZE-QUE M.Nakano   2000 / 9 / 28 ',
  cr,'Not connect AD at starting This program. (Power and signal damages)',cr,
  'Connect After "OK" message.') ; dishelp ;
  WRITELN(cr,'To Oparate AD7707, no param or Add port No.') ; HALT END
  END ;

  pdat:=Memw[paraports:paraporto+prtno*2] ; pstat:=pdat+1 ; pcont:=pdat+2 ;
  IF (pdat=$378)OR(pdat=$3BC)OR(pdat=$278) THEN ELSE
     BEGIN WRITELN('з Ʈ ',prtno,'  ',#7) ; Halt(1) END ;

WRITELN(
'Barometer using AD7707.   C.C.ZE-QUE M.Nakano   2000 / 9 / 28 ') ;
  PORT[pdat]:=0 ;ot(11) ; WRITE('Ready to Connect AD. "OK"') ; cc:=getchar ;
  IF cc IN['q','Q',#27] THEN HALT ; cc:=' ' ;
  iniad ; chs:=0 ; Delay(2000) ;
WRITELN('  Starting conversion. Wait for a few sec.') ;
otr(2,4) (* Clock Register *) ; Delay(1000) ; srat:=4 ;
gant[0]:=5 ; gant[3]:=3 ; modt[0]:=TRUE ; modt[3]:=TRUE ;
otr(1,1) ; otr(2,srat) ;Delay(1000) ; cnt:=0 ;
cali(3) ; otr(1,1) ; Delay(1000) ; cali(0) ; chs:=0 ; erf:=FALSE ;
REPEAT IF NOT erf AND rdy THEN BEGIN
    IF chs=0 THEN BEGIN nda:=in16(chs); otr(1,1); WRITE(chs:2,nda:6);
      chs:=3 ; cali(chs) END
    ELSE BEGIN rbf:=in16(chs) ; otr(1,1) ; WRITE(chs:2,rbf:6) ;
    IF rbf=0 THEN WRITE(' P OVRFLOW') ELSE WRITE(' P ',nda/rbf * 5000 : 7:2) ;
    chs:=0 ; cali(chs) ;
    Inc(cnt) ; IF cnt>2 THEN BEGIN WRITELN ; cnt:=0 END END ;
  END ;
  IF keyprs THEN BEGIN WRITELN ;
    cc:=getchar ; CASE Upcase(cc) OF
'R' : (* Sample Rate *) BEGIN WRITE('R') ; READLN(nbf) ;
   IF nbf>15 THEN WRITELN('  Exceed Range ')
   ELSE BEGIN srat:=nbf AND 15 ; otr(2,srat) END END ;
'S' : (* Select Input *) BEGIN WRITE('S') ; READLN(nbf) ;
   IF nbf>3 THEN WRITELN('  Exceed Range')
   ELSE BEGIN chs:=nbf END  END ;
'I' : (* Initialize AD7707 *) BEGIN
   WRITE('Init') ; iniad ; erf:=FALSE ; cali(chs) END ;
'T' : (* Test *) BEGIN WRITE('T') ; READLN(nbf) ;
   IF nbf>7 THEN WRITELN('  Exceed Range ')
   ELSE BEGIN WRITELN('Reg ',nbf,' = ',inr8(nbf)) END END ;
'E' : (* Enter Register *) BEGIN WRITE('Enter r,v ') ; READLN(rbf,nbf) ;
   IF (rbf>7) THEN BEGIN WRITELN('Exceed reange ') END
   ELSE BEGIN IF rbf<5 THEN otr(rbf,nbf) ELSE otr24(rbf,nbf) END END ;
'C' : (* Calibrate ch N *) BEGIN WRITE('Calib Input ') ; READLN(nbf) ;
   IF nbf>3 THEN WRITELN('Exceed range') ELSE cali(nbf) END ;
'G' : (* Gain set N *) BEGIN WRITE('Gain Input ',chs,' set ') ; READLN(nbf) ;
  IF nbf>7 THEN WRITELN('Exceed range')
  ELSE BEGIN gant[chs]:=nbf ; cali(chs) ; WRITELN('Cali Comp') END END ;
'B': (* Set to Bipola mode *) BEGIN WRITELN('B set ch',chs,' Bipola mode') ;
     modt[chs]:=FALSE END ;
'U': (* Set to Bipola mode *) BEGIN WRITELN('U set ch ',chs,' Unipola mode') ;
     modt[chs]:=TRUE END ;
'/' : (* Display parameters *) dispara ;
'?' : dishelp END (* CASE *) ;
END
UNTIL cc IN['q','Q',#27]
END .
