.xlist
;****************************************************************
;*								*
;*	MS-DOS	standard disk I/O 	 			*
;*								*
;*	Mar / 30 ,1989		ChaN 				*
;*								*
;****************************************************************
;
;
;%1	OPEN_FILE 	: open a file
;%2	CLOSE_FILE	: close a file
;%3	READ_FILE	: read from file
;%4	WRITE_FILE	: write to file
;%5	MAKE_FILE	: make a file
;%6	SEEK_FP		: seek file pointer
;%7	DEL_FILE	: delete a file
;%8	REN_FILE	: rename a file
;%9	SEEK_TAIL	: seek fp to tail point
;%a	CHG_DIR		: change directory
;%b	SEARCH_FILE	: search 1st file
;%c	SEARCH_NEXT	: search next file


;****************************************************************
;%1	Open a file
;
;	acc	= file access control ( 0:R, 1:W, 2:R/W )


OPEN_FILE	macro	acc,str
	IFNB  <str>
		mov	dx,str
	ENDIF
		$DOS  3dh,acc		; open handle
		endm


;****************************************************************
;%2	Close a file
;
;	hand	= file handle


CLOSE_FILE	macro	hand
	IFNB  <hand>
		mov	bx,hand		; set handle
	ENDIF
		$DOS  3eh		; close handle
		endm


;****************************************************************
;%3	Read from file
;
;	hand	= file handle
;	DS	= offset base


READ_FILE	macro	hand,loc,leng
	IFNB  <loc>
		mov	dx,loc
	ENDIF
	IFNB  <leng>
		mov	cx,leng
	ENDIF
	IFNB  <hand>
		mov	bx,hand		; set handle
	ENDIF
		$DOS  3fh		; read handle
		endm


;****************************************************************
;%4	Write to file
;
;	hand	= file handle
;	DS	= offset base


WRITE_FILE	macro	hand,loc,leng
	IFNB  <loc>
		mov	dx,loc
	ENDIF
	IFNB  <leng>
		mov	cx,leng
	ENDIF
	IFNB <hand>
		mov	bx,hand		; set file handle
	ENDIF
		$DOS  40h		; set function 40H write handle
		endm


;****************************************************************
;%5	Make a file
;
;	DS:DX	-> path name
;	attr	= file attribute


MAKE_FILE	macro	attr, path
	IFNB <path>
		mov	dx,path
	ENDIF
		mov	cx,attr		; file attribute
		$DOS  3ch		; create handle
		endm


;****************************************************************
;%6	Seek file pointer
;
;	hand	= file handle
;	CX:DX	= pointer location
;	move	= move control (0:top, 1:add, 2:end)


SEEK_FP		macro	hand, move
	IFNB  <hand>
		mov	bx,hand		; file handle
	ENDIF
		$DOS  42h,move
		endm


;****************************************************************
;%7	Delete a file
;
;	Call	DS:DX -> path name

DEL_FILE	macro	dst
	IFNB <dst>
		mov	dx,dst
	ENDIF
		$DOS  41h		; function 41h delete file
		endm


;****************************************************************
;%8	Rename a file
;
;	DS:DX	-> old path name
;	ES:DI	-> new path name


REN_FILE	macro	dst, src
	IFNB <src>
		mov	dx,dst
		mov	di,src
	ENDIF
		$DOS  56h		; rename file
		endm


;****************************************************************
;%9	Seek FP to file tail
;
;	DS:BX	-> work buffer (1 byte)
;	hand	= file handle
;

SEEK_TAIL	macro	hand
		pusha
		mov	bp,bx
		clr	cx
		clr	dx
		SEEK_FP  hand, 2	; get file size
		mov	cx,dx
		mov	dx,ax
		sub	dx,1
		sbb	cx,0
	_skip b
		mov	si,dx
		mov	di,cx
		SEEK_FP  bx, 0
		READ_FILE  <>,bp,1
	 _skip c
	  _if e, <bptr ds:[bp]>,EOF
		mov	dx,si
		mov	cx,di
		SEEK_FP  bx, 0
	  _endif
	 _endif
	_endif
		popa
		endm


;****************************************************************
;%a	Change Directory
;
;Call	DS:DX -> path
;

CHG_DIR		macro	path
	IFNB <path>
		mov	dx,path
	ENDIF
		$DOS  3bh
		endm


;****************************************************************
;%b	Search 1st file
;
;	attr = attribute mask


SEARCH_FILE	macro	attr,str
		mov	cx,attr
	IFNB  <str>
		mov	dx,str
	ENDIF
		$DOS  4eh
		endm


;****************************************************************
;%c	Search next file

SEARCH_NEXT	macro
		$DOS  4fh
		endm



;**  End of File **
.list
