.xlist
;---------------------------------------------------------------;
;       IBM PC definition                                       ;
;---------------------------------------------------------------;




SEG_BIOS      equ     0040h           ; BIOS work area segment

BIOS_DATA    struc                   ; £ɣϣ ũ
 BiosComLst    dw     4 dup(?) ; COM port address list
 BiosLptLst     dw     4 dup(?) ; LPT port address list
                db      2 dup(?)
                db      ?
                dw     ?
                db      ?
                db      ?
 BiosKbSft      db     ?,?              ; keyboard shift flags
                db      ?
 BiosKbHead    dw     ?               ; key buffer top ptr
 BiosKbTail     dw     ?               ; key buffer tail ptr
 BiosKbBuff    dw      16 dup(?)       ; key buffer
                db      ?               ; recalibration flags
                db      ?               ; motor status
                db      ?               ; motor shut off timer
                db      ?               ; 
                db      7 dup(?) ; FDC status
 BiosVideoMode db      ?               ; current video mode
 BiosCrtWidth   dw     ?               ; CRT width
 BiosCrtSize    dw      ?               ; video buffer size
 BiosCrtTop    dw      ?               ; display top address in video buffer
 BiosCsrPos     dw     8 dup(?) ; cursor posisions
 BiosCsrForm   dw     ?               ; cursor form
 BiosActivePage db     ?               ; active page
                dw     ?               ; CRTC address
                db      ?               ; mode control reg.
                db      ?               ; color select reg.
                db      5 dup(?)
 BiosClock      dd      ?               ; daily timer counter
 BiosClkOvf     db     ?               ; daily timer counter overflow flag
 BiosBreak      db      ?              ; ^Break flag
 BiosSreset     dw      ?               ; software reset command
                db      ?
                db      ?
                db      ?
                db      ?
                db      4 dup(?)
                db      4 dup(?)
                dw     ?
                dw     ?
 BiosCrtRows   db      ?               ; screen lines -1
 BiosCharLines dw      ?               ; char. size (lines)
                db      79h dup(?)      ; (other parameters)
 BiosPrnScFlag db      ?               ; print screen job flag
BIOS_DATA    ends



$VIDEO        macro   func,par ; video I/F
        IFNB <par>
                mov    ax,(func shl 8)+(par and 0ffh)
        ELSE
                mov    ah,func
        ENDIF
                 int     10h
                endm

$PRINT        macro   func,par ; printer I/F
        IFNB <par>
                mov    ax,(func shl 8)+(par and 0ffh)
        ELSE
                mov    ah,func
        ENDIF
                 int     17h
                endm

$KEY          macro   func,par ; keyboard I/F
        IFNB <par>
                mov    ax,(func shl 8)+(par and 0ffh)
        ELSE
                mov    ah,func
        ENDIF
                 int     16h
                endm

$RTC          macro   func,par ; RTC I/F
        IFNB <par>
                mov    ax,(func shl 8)+(par and 0ffh)
        ELSE
                mov    ah,func
        ENDIF
                 int     1ah
                endm

$DISK          macro  func,par ; DISK I/F
        IFNB <par>
                mov    ax,(func shl 8)+(par and 0ffh)
        ELSE
                mov    ah,func
        ENDIF
                int      13h
                endm

$SYSTEM              macro  func,par ; system service I/F
        IFNB <par>
                mov    ax,(func shl 8)+(par and 0ffh)
        ELSE
                mov    ah,func
        ENDIF
                 int     15h
                endm


;**  End of File **
.list
