.xlist
.sall
;********************************
;*          *
;* ģϣ ǥ   *
;*          *
;* (C)ChaN, 1989    *
;*          *
;********************************

;------------------------------------------------------------------------------
; ASCII control code definition

   NUL   equ   0 ; null character
   CR equ   0dh  ; carriage return
   LF equ   0ah  ; line feed
   FF equ   0ch  ; form feed
   BS equ   08h  ; back space
   BEL   equ   07h  ; bell
   TAB   equ   09h  ; holizontal tabulation
   EOF   equ   1ah  ; end of file
   ESC   equ   1bh  ; escape
   DEL   equ   7fh  ; delete
   ACK   equ   06h  ; acknoridge


;------------------------------------------------------------------------------
; Bit operation

   BIT0 equ   0000000000000001b
   BIT1 equ   0000000000000010b
   BIT2 equ   0000000000000100b
   BIT3 equ   0000000000001000b
   BIT4 equ   0000000000010000b
   BIT5 equ   0000000000100000b
   BIT6 equ   0000000001000000b
   BIT7 equ   0000000010000000b
   BIT8 equ   0000000100000000b
   BIT9 equ   0000001000000000b
   BIT10 equ  0000010000000000b
   BIT11 equ  0000100000000000b
   BIT12 equ  0001000000000000b
   BIT13 equ  0010000000000000b
   BIT14 equ  0100000000000000b
   BIT15 equ  1000000000000000b


;------------------------------------------------------------------------------
; Flag op.

   ON equ   -1
   OFF   equ   0

;------------------------------------------------------------------------------
; Stack op.

   push equ   pushm    ; OPTASM
   pop   equ   popm    ; OPTASM

;------------------------------------------------------------------------------
; Type

   bptr equ   byte ptr
   wptr equ   word ptr
   dwptr equ  dword ptr
   ofs   equ   offset
   len   equ   length


;------------------------------------------------
; PSP

DEF_PSP    macro
      org   0
      db 10 dup(?)  ; old parameters
 PspInt22  dd ?     ; termination address
 PspInt23  dd ?     ; control-Break hander address
 PspInt24  dd ?     ; critical error handler address
 PspPpsp dw ?    ; parent PSP segment
 PspJft     db 20 dup(?) ; default Job File Table
 PspEnv     dw ?    ; envilonment segment
      dd ?     ; SS:SP on entry to last INT 21h
 PspJftNum dw ?     ; number of entries in JFT
 PspJftPtr dd ?     ; pointer to JFT
      dd ?     ; pointer to previos PSP
      db 4 dup(?) ; unused
 PspVer     db ?,?     ; version number (to return on function 30h)
      db 14 dup(?)  ; unused
      db 3 dup(?) ; INT21h/retf code
      db 9 dup(?) ; unused
 PspFcb1 db 16 dup(?) ; 1st FCB (filled by 1st commnad line argument)
 PspFcb2 db 16 dup(?) ; 2nd FCB (filled by 2nd commnad line argument)
      db 4 dup(?) ; unused
 PspDta     db 128 dup(?) ; command line / default DTA
      endm




;**********************************************
; ǥ ũ
;**********************************************

$DOS macro func,par    ;; ģϣ 
    IFNB <par>
   mov   ax,(func SHL 8)+(par AND 0ffh)
    ELSE
   mov   ah,func
    ENDIF
   int   21h
   endm

$EMM macro func,par    ;; ţͣ 
    IFNB <par>
   mov   ax,(func shl 8)+(par and 0ffh)
    ELSE
   mov   ah,func
    ENDIF
   int   67h
   endm


movseg   macro dst,src    ;; ׸Ʈ 
   push src
   pop   dst
   endm

sds   macro dst,src    ;; far  
   mov   wptr dst[0],src
   mov   wptr dst[2],ds
   endm

ses   macro dst,src
   mov   wptr dst[0],src
   mov   wptr dst[2],es
   endm

inp   macro reg,port ;; Ʈ 
   mov   dx,port
   in reg,dx
   endm

outp macro port,reg ;; Ʈ Է
   mov   dx,port
   out   dx,reg
   endm

inb   macro dest,port ;; input byte
    IF (((.type port) and 14) ne 0)
   inp   al,port
    ELSE
     IF port ge 100h
   inp   al,port
     ELSE
   in al,port
     ENDIF
    ENDIF
   mov   dest,al
   endm

outb macro port,src ;; output byte
   mov   al,src
    IF (((.type port) and 14) ne 0)
   outp port,al
    ELSE
     IF port ge 100h
   outp port,al
     ELSE
   out   port,al
     ENDIF
    ENDIF
   endm

inw   macro dest,port ;; input word
    IF   port ge 100h
   inp   ax,port
    ELSE
   in ax,port
    ENDIF
   mov   dest,ax
   endm

outw macro port,src ;; output word
   mov   ax,src
    IF   port ge 100h
   outp port,ax
    ELSE
   out   port,ax
    ENDIF
   endm


set   macro dest,bt    ;; Ʈ Ʈ or ÷ Ʈ
    IFNB <bt>
   or dest,bt
    ELSE
   mov   dest,ON
    ENDIF
   endm
   
res   macro dest,bt    ;; Ʈ  or ÷ 
    IFNB <bt>
   and   dest,not bt
    ELSE
   mov   dest,OFF
    ENDIF
   endm

cpl   macro dest,bt    ;; Ʈ øƮ or ÷ øƮ
    IFNB <bt>
   xor   dest,bt
    ELSE
   not   dest
    ENDIF
   endm

tst   macro dest    ;; value üũ
   cmp   dest,0
   endm

clr   macro r1,r2,r3 ;;  Ŭ
   xor   r1,r1
    IFNB <r2>
   xor   r2,r2
    ENDIF
    IFNB <r3>
   xor   r3,r3
    ENDIF
   endm

setpb macro port,dat ;; I/O port logical op.
    IF port ge 100h
   inp   al,port
   set   al,dat
   out   dx,al
    ELSE
   in al,port
   set   al,dat
   out   port,al
    ENDIF
   endm

respb macro port,dat ;; I/O port logical op.
    IF port ge 100h
   inp   al,port
   res   al,dat
   out   dx,al
    ELSE
   in al,port
   res   al,dat
   out   port,al
    ENDIF
   endm

tstpb macro port,dat ;; I/O port bit test
    IF (((.type port) and 14) ne 0)
   inp   al,port
    ELSE
     IF port ge 100h
   inp   al,port
     ELSE
   in al,port
     ENDIF
    ENDIF
   test al,dat
   endm

incw macro d1    ;; increment word
     inc    d1
     inc    d1
   endm

decw macro d1    ;; decrement word
     dec    d1
     dec    d1
   endm

addi macro dst,src1,src2 ;; add and move
   mov   dst,src1
   add   dst,src2
   endm

andi macro dst,src1,src2 ;; and and move
   mov   dst,src1
   and   dst,src2
   endm

ori   macro dst,src1,src2 ;; or and move
   mov   dst,src1
   or dst,src2
   endm

subi macro dst,src1,src2 ;; subtract and move
   mov   dst,src1
   sub   dst,src2
   endm



$ret equ   ret         ;; OPTASM
ret   equ   _ret       ;; OPTASM
retn equ   _retn       ;; OPTASM

_ret macro cc,dst,src     ;; /   OPTASM
   local l
  IFNB   <cc>
   IFNB  <dst>
   cmp   dst,src
   ENDIF
   jn&cc l
   $ret
l:
  ELSE
   $ret
  ENDIF
   endm

_retn macro cc,dst,src    ;;    OPTASM
   local l
  IFNB  <dst>
   cmp   dst,src
  ENDIF
   j&cc l
   $ret
l:
   endm



;************************************************
; ȭ ũ
;************************************************

   irpc n,0123456789      ;;  8 ׽Ʈ 
   $LP&n = 0
   endm

   $LNUM = 0
   $NEST = 0

   $CASEB   = 10       ;; case block
   $CASEN   = 0
   $INCASE = OFF


$rcb macro cc,c1,c2    ;;   (BLOCK)
  IFIDN <cc>,<c1>
   $jcc c2,%$NEST,%$LNUM
  ENDIF
  IFIDN <cc>,<c2>
   $jcc c1,%$NEST,%$LNUM
  ENDIF
   endm


_if   macro cc,dst,src    ;;   
   $enter   %$NEST,%($NEST+1)  ;; cc ߴٸ  
   $LNUM = $LNUM+1
  IFNB <src>
   cmp   dst,src
  ELSE
   IFNB <dst>
   dst
   ENDIF
  ENDIF
  IRP ccc,<<c,nc>,<e,ne>,<z,nz>,<b,nb>,<a,na>,<g,ng>,<l,nl>,<be,nbe>,<ae,nae>,<
ge,nge>,<le,nle>,<s,ns>,<cxz,ncxz>>
   $rcb cc,ccc
  ENDM
   endm

_skip macro cc,dst,src    ;;  ŵ
   $enter   %$NEST,%($NEST+1)  ;; cc ϸ  ŵ
   $LNUM = $LNUM+1
  IFNB <src>
   cmp   dst,src
  ELSE
   IFNB <dst>
   dst
   ENDIF
  ENDIF
   $jcc cc,%$NEST,%$LNUM
   endm

@if   macro cc,inst       ;;  ܵ ɣ
   local l1
   jn&cc l1
   inst
l1:
   endm

@ifn macro cc,inst        ;;  ܵ ɣ
   local l1
   j&cc l1
   inst
l1:
   endm

_else macro         ;; ݴ  
   $jcc <>,%$NEST,%($LNUM+1)
   $label   %$NEST,%$LNUM
   $LNUM = $LNUM+1
   endm

_endif   macro         ;;   
   $label   %$NEST,%$LNUM
   $leave   %$NEST,%($NEST-1)
   endm

__endif macro          ;;   ܣã
   _endif
   _endif
   endm

___endif macro            ;;   ܣã
   _endif
   _endif
   _endif
   endm

____endif macro           ;;   ܣã
   _endif
   _endif
   _endif
   _endif
   endm


_repeat macro count, dst,src      ;; REPEAT  ãΣ
   $enter   %$NEST,%($NEST+1)  ;; count ϸ cx  ε
  IFNB   <count>
   IFB <dst>
   mov   cx,count
   ENDIF
  ENDIF
   $LNUM = $LNUM+1
   $label   %$NEST,%$LNUM
  IFNB <dst>
   IFNB <src>
   cmp   dst,src
   ELSE
  dst
   ENDIF
   $LNUM = $LNUM+1
   IRP ccc,<<c,nc>,<e,ne>,<z,nz>,<b,nb>,<a,na>,<g,ng>,<l,nl>,<be,nbe>,<ae,nae>,
<ge,nge>,<le,nle>,<s,ns>,<cxz,ncxz>>
   $rcb count,ccc
   ENDM
   $LNUM = $LNUM-1
  ENDIF
   endm


_while   equ  _repeat        ;; _repeat 


_break   macro cc,dst,src   ;; cc  , 
  IFNB <src>           ;; REPEAT   ´
   cmp   dst,src
  ELSE
   IFNB <dst>
   dst
   ENDIF
  ENDIF
   $jcc cc,%$NEST,%($LNUM+1)
   endm

_cont macro cc,dst,src    ;; cc  ,
  IFNB <src>           ;; REPEAT  κ 簳Ѵ
   cmp   dst,src
  ELSE
   IFNB <dst>
   dst
   ENDIF
  ENDIF
   $jcc cc,%$NEST,%$LNUM
   endm

_rept macro cc,dst,src    ;; REPEAT  
  IFNB <src>           ;; cc ϴ , ο ̸ ݺѴ
   cmp   dst,src       ;; cc ϸ ׻ 
  ELSE
   IFNB <dst>
   dst
   ENDIF
  ENDIF
   $jcc cc,%$NEST,%$LNUM
   $LNUM = $LNUM+1
   $label   %$NEST,%$LNUM
   $leave   %$NEST,%($NEST-1)
   endm

_loop macro cc,dst,src    ;; REPEAT  
  IFNB <src>           ;; ο ̿ loop 
   cmp   dst,src       ;; cc  
  ELSE
   IFNB <dst>
   dst
   ENDIF
  ENDIF
   $loop cc,%$NEST,%$LNUM
   $LNUM = $LNUM+1
   $label   %$NEST,%$LNUM
   $leave   %$NEST,%($NEST-1)
   endm




$rcc macro cc,c1,c2    ;;    (CASE)
  IFIDN <cc>,<c1>
   $cjcc c2,%$CASEB,%$CASEN
  ENDIF
  IFIDN <cc>,<c2>
   $cjcc c1,%$CASEB,%$CASEN
  ENDIF
   endm


_case macro cc,dst,src    ;; ̽ 
  IF $INCASE ne ON
   $INCASE = ON
   $CASEN = 0
  ELSE
   $cjcc <>,%$CASEB,T
  ENDIF
   $labc %$CASEB,%$CASEN
   $CASEN = $CASEN+1
  IFNB <src>
   cmp   dst,src
  ELSE
   dst
  ENDIF
  IRP ccc,<<c,nc>,<e,ne>,<z,nz>,<b,nb>,<a,na>,<g,ng>,<l,nl>,<be,nbe>,<ae,nae>,<
ge,nge>,<le,nle>,<s,ns>,<cxz,ncxz>>
   $rcc cc,ccc
  ENDM
   endm

_default macro
   $cjcc <>,%$CASEB,T
   $labc %$CASEB,%$CASEN
   $CASEN = $CASEN+1
   endm

_endc macro
   $labc %$CASEB,%$CASEN
   $labc %$CASEB,T
   $CASEB   = $CASEB+1
   $INCASE = OFF
   endm




$enter   macro a,b        ;; ׽Ʈ 
  IF $NEST ge 8        ;; 
   %out * Nesting Over! *
  ENDIF
   $LP&a = $LNUM
   $LNUM = $LP&b
   $NEST = $NEST+1
   endm

$leave   macro a,b        ;; ׽Ʈ ƿ
  IF $NEST  eq 0
   %out * Nesting Over! *
  ENDIF
   $LP&a = $LNUM
   $LNUM = $LP&b
   $NEST = $NEST-1
   endm

$label   macro l,m        ;; BLOCK ̺ 
$&l&m:
   endm

$labc macro l,m        ;; CASE ̺ 
$C&l&m:
   endm



$jcc macro cc,l,m         ;;   
  IFNB <cc>
   j&cc $&l&m
  ELSE
   jmp   $&l&m
  ENDIF
   endm

$cjcc macro cc,l,m        ;;   
  IFNB <cc>
   j&cc $C&l&m
  ELSE
   jmp   $C&l&m
  ENDIF
   endm

$jncc macro cc,l,m        ;;   
   jn&cc $&l&m
   endm


$loop macro cc,l,m        ;; LOOP  
   loop&cc $&l&m
   endm


$end macro l        ;; α׷ ó
    IF   $NEST ne 0
   %out *** Block Macro Open Nest ***
    ENDIF
   end   l
   endm


;*****************
;** END OF FILE **
;*****************
.list
