.xlist
;********************************
;*                              *
;*      ڿ              *
;*                              *
;********************************


;-------------------------------------------------------------------------
-----
;       -- MACRO LIBRARY INDEX --
;
;%1     PRINT         : string screen output
;%2     CON_IN        : input string
;%3     ERR_OUT              : output error code
;%4     GET_CMD_PAR : get command line parameter
;%5     GET_VAL_F   : get value of decimal string
;       GET_VALD_F   : get value of decimal string
;%6     GET_VALH_F : get value of hexdecimal string
;%7     MAKE_DEC_F : make decimal string
;       MAKE_DECD_F : make decimal string
;%8     MAKE_HEX_F  : make hexdesimal string
;%9     PRINTF_F      : forming screen output
;%A    CMP_STR              : compare string
;%B    CPY_STR               : copy string
;%C    FIL_STR                : fill string buffer
;%D    MOV_MEM             : copy memory
;%E    CAPS           : caps
;       UNCAPS                : uncaps



;****************************************************************
;%1     Console Output
;
;       DS:MSG        -> string


PRINT          macro  msg
                mov    dx,ofs msg      ; set string top address
                $DOS  9                        ; display string
                endm



;****************************************************************
;%2     Console Input
;
;ent     DS:BX -> ASCIZ string
;ret     CX = character number

CON_IN_F      macro

CON_IN        proc
                push    bx
                clr      cx
        _while
                $DOS  8
         _break e, al,CR
         _if ae, al,' '
                int      29h
                mov    [bx],al
                inc     bx
                inc     cx
         _else
          _if e, al,BS
           _if ne, cx,0
                int      29h
                dec     bx
                dec     cx
         ___endif
        _rept
                int      29h
                mov    bptr[bx],0
                pop     bx
                ret
CON_IN        endp

                endm


;****************************************************************
;%3     Error output
;
;       Input    AL     = error code


ERR_OUT              macro
                aam                            ; get decimal code from al
                add     ax,3030h        ; make numeric characters
                xchg    ah,al
                mov    bx,ofs $$Mess
                mov    cs:[bx][13],ax
        _repeat
                mov    al,cs:[bx]
                inc     bx
                 int     29h
        _rept ne, al,BEL
        _skip
$$Mess         db      CR,LF,'DOS ERROR #??',CR,LF,BEL
        _endif

                endm


;***************************************************************
;%4     Get command line parameters
;
;       Return  DS:[count]       = palameter count byte
;               DS:[buff]        = ASCIZ strings address ptr table
;                               { 1st parameter ptr      }
;                               {   DS:[buff +0] }
;                               { 2nd parameter ptr      }
;                               {   DS:[buff +2] }
;                               { 3rd .....                }
;


GET_CMD_PAR macro  count, buff
                local    mlp1

                mov    count,0
                mov    si,81h
                mov    di,ofs buff
mlp1:
        _while ne, bptr[si],CR
         _if be, bptr[si],' '
                mov    bptr [si],0
                inc     si
                jmp     mlp1
         _endif
                mov    [di],si
                add     di,2
                inc     count
         _while nbe, bptr[si],' '
                inc     si
         _rept
        _rept
                mov    bptr[si],0

                endm



;***************************************************************
;%5     Get value of ASCIZ decimal string
;
;Call    DS:BX          -> ASCIZ string
;Ret    CF=0   AX     = value
;               DS:BX  -> tail char ( =< 20h)
;       CF=1    AX    = 0 (error)
;               DS:BX  -> err char

GET_VAL_F    macro
                local    err1

GET_VAL              proc
                push    cx,dx
                clr      ax,cx
        _repeat
                mov    cl,[bx]
         _break be, cl,' '
                sub     cl,'0'
                jb      err1
                cmp    cl,9
                ja      err1
                mov    dx,10
                mul     dx
                add     ax,cx
                inc     bx
        _rept
                pop     dx,cx
                clc
                ret
err1:            pop     dx,cx
                clr      ax
                stc
                ret
GET_VAL              endp

                endm

;-------------------------------;
;Ret    CF=0   DXAX  = value
;               DS:BX  -> tail char ( =< 20h)
;       CF=1    DXAX = 0 (error)
;               DS:BX  -> err char

GET_VALD_F  macro
                local    err1

GET_VALD     proc
                push    cx,si,di
                clr      ax,dx,cx
        _repeat
                mov    cl,[bx]
         _break be, cl,' '
                sub     cl,'0'
                jb      err1
                cmp    cl,9
                ja      err1
                mov    si,ax
                mov    di,dx
                push    cx
         _repeat 9
                add     ax,si
                adc     dx,di
         _loop
                pop     cx
                add     ax,cx
                adc     dx,0
                inc     bx
        _rept
                pop     di,si,cx
                clc
                ret
err1:            pop     di,si,cx
                clr      ax,dx
                stc
                ret
GET_VALD     endp

                endm



;***************************************************************
;%6     Get value of ASCIZ hexdecimal string
;
;       Call     DS:BX          -> ASCIZ string
;
;       Return  CF=0
;                AX            = value
;                DS:BX         -> tail cahr <0>
;               CF=1 (Error)
;                AX            = 0
;                DS:BX         -> err char


GET_VALH_F  macro
                local    err1

GET_VALH     proc

                push    dx
                clr      dx
        _repeat
                mov    al,[bx]
         _break be, al,' '
                cmp    al,'`'
         @if ae,<sub    al,20h>
                sub     al,'0'
                jb      err1
         _if a, al,9
                cmp    al,17
                jb      err1
                sub     al,7
                cmp    al,15
                ja      err1
         _endif
                shl     dx,4
                or      dl,al
                inc     bx
        _rept
                mov    ax,dx
                pop     dx
                clc
                ret
err1:
                pop     dx
                clr      ax
                stc
                ret

GET_VALH     endp

                endm



;***************************************************************
;%7     Convert AX to decimal string
;
;Call    AX     = value (0 to 65535)
;       DS:BX  -> ASCIZ string buffer (5+1 bytes)


MAKE_DEC_F  macro

MAKE_DEC    proc
                push    ax,bx,cx,dx
                add     bx,5
                mov    bptr[bx],0
        _repeat 5
                push    cx
                clr      dx
                mov    cx,10
                div     cx
                add     dl,'0'
                dec     bx
                mov    [bx],dl
                pop     cx
        _loop
        _repeat 4
         _break ne, bptr[bx],'0'
                mov bptr[bx],' '
                inc     bx
        _loop
                pop     dx,cx,bx,ax
                ret
MAKE_DEC    endp

                endm

;------------------------------------------;
;Call    DXAX = value (0..4294967295)
;       DS:BX  -> ASCIZ decimal string buffer

MAKE_DECD_F macro

MAKE_DECD   proc
                push    ax,bx,cx,dx,si,di
                clr      si
        _while
                mov    cx,2000h
         _while
                shl     ax,1
                rcl      dx,1
                rcl      cl,1
          _if ae, cl,10
                sub     cl,10
                set     al,BIT0
          _endif
         _rept nz,<dec  ch>
                inc     si
                push    cx
                mov    di,ax
                or      di,dx
        _rept nz
        _repeat si
                pop     ax
                add     al,'0'
                mov    [bx],al
                inc     bx
        _loop
                mov    bptr[bx],0
                pop     di,si,dx,cx,bx,ax
                ret
MAKE_DECD   endp

                endm





;***************************************************************
;%8     Convert AX to hexdecimal string
;
;       Call     AX             = value
;               DS:BX          -> string buffer (4 bytes)
;

MAKE_HEX_F macro

MAKE_HEX    proc
                push    ax,bx,cx
        _repeat 4
                rol      ax,4
                push    ax
                and     al,0fh
                add     al,'0'
                cmp    al,'9'
         @if a,<add     al,7>
                mov    [bx],al
                inc     bx
                pop     ax
        _loop
                pop     cx,bx,ax
                ret

MAKE_HEX    endp

                endm


;***************************************************************
;%9     Forming string output
;
;       Call     SS:BP          -> parameter list
;
;       ex.      mov    bp,sp
;               push   ofs Form, Par1, Par2,....
;                call    PRINTF
;
; %c    char (DB/SB)
; %s    string (offset)
; %i    signed int
; %ui   unsigned int
; %l    signed long
; %ul   unsigned long
; %h<n>       hex, n = 1..4(word)/5..8(dword)
; %%   %
; %n   CRLF
; %m   CR


PRINTF_F      macro
PRINTF        proc
                pusha
                decw   bp
                mov    si,[bp]
_pfmlp:
                mov    al,[si]
                inc     si
                cmp    al,0
                je      _pfend
                cmp    al,'%'
                je      _pfchk
                 int     29h
                jmp     _pfmlp
_pfend:
                popa
                pop     ax
                mov    sp,bp
                jmp     ax
_pfchk:
                mov    ax,[si]
                inc     si
        _case e, al,'n'                           ; CRLF ?
                mov    al,CR
                 int     29h
                mov    al,LF
                 int     29h

        _case e, al,'m'                          ; CR ?
                mov    al,CR
                 int     29h

        _case e, al,'s'                           ; string ?
                decw   bp
                mov    bx,[bp]
         _repeat
                mov    al,[bx]
                inc     bx
          _break e, al,0
                 int     29h
         _rept

        _case e, al,'h'                           ; hexdecimal ?
                inc     si
                sub     ah,'0'
                cmp    ah,5
                mov    cx,0402h
         @if ae,<shl    cx,1>
                sub     ch,ah
         _repeat
                dec     bp
                 call    _pfhex
                 call    _pfhex
                dec     cl
         _rept nz

        _case e, al,'i'                           ; integer ?
                decw   bp
                mov    dx,[bp]
         _if s,<tst dh>
                mov    al,'-'
                 int     29h
                neg     dx
         _endif
                 call    _pfint

        _case e, ax,'iu'                  ; unsigned int ?
                inc     si
                decw   bp
                mov    dx,[bp]
                 call    _pfint

        _case e, al,'l'                           ; long ?
                sub     bp,4
                mov    dx,[bp]
                mov    cx,[bp].2
         _if s,<tst ch>
                mov    al,'-'
                 int     29h
                not     cx
                not     dx
                inc     dx
                adc     cx,0
         _endif
                 call    _pflng

        _case e, ax,'lu'                  ; unsigned long ?
                inc     si
                sub     bp,4
                mov    dx,[bp]
                mov    cx,[bp].2
                 call    _pflng

        _case e, al,'c'                           ; character ?
                decw   bp
                mov    ax,[bp]
         _if ne, ah,0
                xchg    al,ah
                 int     29h
                xchg    al,ah
         _endif
                 int     29h

        _default
                 int     29h

        _endc
                jmp     _pfmlp

_pfhex:
                mov    al,[bp]
                ror     al,4
                mov    [bp],al
                and     al,1111b
                cmp    al,9
        @if a, <add     al,7>
                add     al,'0'
                tst      ch
        _if z
                 int     29h
                ret
        _endif
                dec     ch
                ret

_pfint:
                mov    cx,0
        _repeat
                mov    ax,1000h
         _repeat
                shl     dx,1
                rcl      al,1
          _if ae, al,10
                sub     al,10
                set     dl,BIT0
          _endif
         _rept nz,<dec ah>
                inc     cx
                push    ax
        _rept nz,<tst dx>
        _repeat
                pop     ax
                add     al,'0'
                 int     29h
        _loop
                ret

_pflng:
                mov    bx,0
        _repeat
                mov    ax,2000h
         _repeat
                shl     dx,1
                rcl      cx,1
                rcl      al,1
          _if ae, al,10
                sub     al,10
                set     dl,BIT0
          _endif
         _rept nz,<dec ah>
                inc     bx
                push    ax
                mov    ax,dx
                or      ax,cx
        _rept nz
        _repeat bx
                pop     ax
                add     al,'0'
                 int     29h
        _loop
                ret

PRINTF        endp

                endm


;***************************************************************
;%A    Compare string
;
;

CMP_STR              macro   src,dst,count
        IFNB  <src>
                mov    si,src
        ENDIF
        IFNB  <dst>
                mov    di,dst
        ENDIF
        IFNB  <count>
                mov    cx,count
        ENDIF
                cld
                repe cmpsb
                endm


;***************************************************************
;%B    Copy a string
;

CPY_STR               macro  src,dst
        IFNB  <src>
                mov    si,src
        ENDIF
        IFNB  <dst>
                mov    di,dst
        ENDIF
                cld
        _repeat
                movsb
        _rept ne, bptr[si][-1],0
                dec     di
                endm


;***************************************************************
;%C    Fill String Buffer
;

FIL_STR               macro   dst,cnt,dat
        IFNB  <dst>
                mov    di,dst
        ENDIF
        IFNB  <cnt>
                mov    cx,cnt
        ENDIF
        IFNB  <dat>
                mov    al,dat
        ENDIF
                cld
                rep stosb
                endm


;***************************************************************
;%D    block move
;

MOV_MEM             macro  src,dst,cnt
        IFNB  <src>
                mov    si,src
        ENDIF
        IFNB  <dst>
                mov    di,dst
        ENDIF
        IFNB  <cnt>
                mov    cx,cnt
        ENDIF
                cld
                rep movsb
                endm


;***************************************************************
;%E    caps convert
;

CAPS          macro   dst
        _skip a, dst,'z'
         _skip b, dst,'a'
                sub     dst,20h
        __endif
                endm

UNCAPS               macro   dst
        _skip a, dst,'Z'
         _skip b, dst,'A'
                add     dst,20h
        __endif
                endm



;******************
;**  End of File **
;******************
.list
