/*
  vecmath.cpp
   (C)Mathematical Assist Design Lab. 1996/1/1 Hal.T
  (C)ͪϼᶡHal.T 1986.1
  2,3,N   ̺귯
*/

#include "vecmath.h"
//--------------------------------------
//  ʱȭѴ
template  <class  T>  VecN<T>::VecN(VecN<T> &v)
{
  vp = new T[vn = v.vn];
  for(int k=0;  k<vn; k++) vp[k] =  v.vp[k];
}
//--------------------------------------
//  ʱȭѴ
template  <class  T>  VecN<T>::VecN(int n,  T *p)
{
  vp = new T[vn = n];
  if(p) { for(int k=0;  k<n; k++) vp[k] =  p[k];  }
}
//--------------------------------------
//밪
template  <class  T>  T abs(VecN<T> &v)
{
  T  d = 0.0;
  for(int k=0;  k<v.vn; k++)  d +=  v.vp[k]*v.vp[k];
  return  sqrt(d);
}
//--------------------------------------

template  <class  T>  VecN<T>& VecN<T>::operator=(VecN<T> &src)
{
  for(int k=0;  k<this->vn;  k++)  this->vp[k]  = src.vp[k];
  return *this;
}
//--------------------------------------
template  <class  T>  VecN<T> operator+(VecN<T> &p, VecN<T> &q)
{
  VecN<T> vt = p;
  for(int k=0;  k<vt.vn;  k++)  vt.vp[k]  += q.vp[k];
  return vt;
}
//--------------------------------------
template  <class  T>  VecN<T> operator-(VecN<T> &p, VecN<T> &q)
{
  VecN<T> vt = p;
  for(int k=0;  k<vt.vn;  k++)  vt.vp[k]  -= q.vp[k];
  return vt;
}
//--------------------------------------
template  <class  T>  VecN<T> operator*(VecN<T> &p, VecN<T> &q)
{
  VecN<T> vt = p;
  for(int k=0;  k<vt.vn;  k++)  vt.vp[k]  *= q.vp[k];
  return vt;
}
//--------------------------------------
template  <class  T>  VecN<T> operator*(T a, VecN<T> &p)
{
  VecN<T> vt = p;
  for(int k=0;  k<vt.vn;  k++)  vt.vp[k]  *= a;
  return vt;
}
//--------------------------------------
template  <class  T>  VecN<T> operator*(VecN<T> &p, T a)
{
  VecN<T> vt = p;
  for(int k=0;  k<vt.vn;  k++)  vt.vp[k]  *= a;
  return vt;
}
//--------------------------------------
template  <class  T>  VecN<T> operator/(VecN<T> &p, T a)
{
  VecN<T> vt = p;
  for(int k=0;  k<vt.vn;  k++)  vt.vp[k]  /= a;
  return vt;
}
//--------------------------------------
template  <class  T>  int operator==(VecN<T> &p, VecN<T> &q)
{
  int k,  t = -1;
  for(k=0;  k<p.vn && t;  k++)  {
    t = (p.vp[k] == q.vp[k]);
  }
  return t;
}
//--------------------------------------
template  <class  T>  int operator!=(VecN<T> &p, VecN<T> &q)
{
  for(int k=0;  k<p.vn;  k++)  {
    if(p.vp[k] != q.vp[k])  return -1;
  }
  return 0;
}
//--------------------------------------
template  <class  T>  VecN<T> &VecN<T>::operator+=(VecN<T> &p)
{
  for(int k=0;  k<vn;  k++)  vp[k]  += p.vp[k];
  return *this;
}
//--------------------------------------
template  <class  T>  VecN<T> &VecN<T>::operator-=(VecN<T> &p)
{
  for(int k=0;  k<vn;  k++)  vp[k]  -= p.vp[k];
  return *this;
}
//--------------------------------------
template  <class  T>  VecN<T> &VecN<T>::operator*=(T a)
{
  for(int k=0;  k<vn;  k++)  vp[k]  *= a;
  return *this;
}
//--------------------------------------
template  <class  T>  VecN<T> &VecN<T>::operator/=(T a)
{
  for(int k=0;  k<vn;  k++)  vp[k]  /= a;
  return *this;
}
//--------------------------------------

template  <class  T>  VecN<T> VecN<T>::operator-()
{
  VecN<T> vt(this->vn);
  for(int k=0;  k<vn;  k++)  vt[k]  = -vp[k];
  return vt;    //Ͻ  īǸ ֹǷ 
}
//--------------------------------------
template  <class  T>   VecN<T>& operator=(const  VecN<T> &src)
{
  for(int k=0;  k<vn;  k++)  vp[k]  = src[k];
  return *this;
}
//--------------------------------------
template  <class  T>  ostream &operator<<(ostream &s, VecN<T> &p)
{
  s << '[';
  for(int n=0;  n<p.vn; ) {
    s << p.vp[n++];
    if(n < p.vn)  s << ", ";
  }
  s << ']'; return  s;
}
//======================================
//--------------------------------------
template  <class  T>  VecMtx<T>::VecMtx(int colum,  int  row)
{
  Colum = colum;    Row = row;
  vp  = new VecN<T> [Colum];
  for(int k = 0;  k<Colum;  k++)  vp[k].SetDimN(Row);
}
//--------------------------------------
template  <class  T>  VecMtx<T>::VecMtx(VecMtx<T> &m)
{
  Colum = m.Colum;    Row = m.Row;
  vp  = new VecN<T> [Colum];
  for(int k = 0;  k<Colum;  k++)  vp[k].SetDimN(Row);
}
//--------------------------------------
template  <class  T>  VecMtx<T>::~VecMtx()
{
  delete  []  vp;
//  for(int k = 0;  k<Colum;  k++)  delete  vp[k];
}
//--------------------------------------
template  <class  T>  ostream &operator<<(ostream &s, VecMtx<T> &p)
{
  for(int n=0;  n<p.Colum; )  s << p.vp[n++] << '\n';
  return  s;
}
//--------------------------------------
// 밢 1ϰ,  1 س. ǺƮ 
// 
template  <class  T>  void VecMtx<T>::SolveC1(void)
{
  int nC1, nC2;
  T  tmpCC;

  for(nC1 = 1;  nC1 < Colum; nC1++) {
    tmpCC = vp[nC1][nC1];
    for(nC2 = 1;  nC2 < Colum;  nC2++)  {
//    cout << *this << " " << nC1 << " " << nC2 << "\n\n";
      if(nC1 != nC2)  vp[nC2] -=  (vp[nC2][nC1]/tmpCC)*vp[nC1];
//    cout << *this << "\n\n";
    }
  }

  for(nC1=1;  nC1 < Colum;  nC1++)  { //  밢Ҹ 1 ԰ȭѴ
    tmpCC = 1.0/vp[nC1][nC1];
    vp[nC1] *=  tmpCC;
  }
}
//======================================
//--------------------------------------
//======================================
//--------------------------------------
//======================================
//#define DEBUG


#ifdef  DEBUG
void  test1()
{
  _InitEasyWin();
  VecMtx<double> m(4,4);
  m[0][0] = 10.0; m[0][1] = 1.0;  m[0][2] = 2.0;  m[0][3] = 2.0;
  m[1][0] =  0.0; m[1][1] =11.0;  m[1][2] = 3.0;  m[1][3] = 1.0;
  m[2][0] =  1.0; m[2][1] = 2.0;  m[2][2] =12.0;  m[2][3] = 2.0;
  m[3][0] =  3.0; m[3][1] = 1.0;  m[3][2] = 1.0;  m[3][3] =13.0;

  cout << m << "\n\n";
  m.SolveC1();
  cout << m << "\n\n";

}
#endif
//--------------------------------------

