#if !defined(__VECTORN_H)
#define __VECTORN_H
/*
  vecmath.h
  (C)Mathematical Assist Design Lab. 1996/1/1 Hal.T
  (C)ͪϼᶡHal.T 1986.1
  2,3,N   ̺귯
*/

#ifndef __cplusplus
#error Must use C++ for the type Vec2.
#endif

#if !defined(__IOSTREAM_H)
#include <iostream.h>
#endif

#pragma option -Vo-

#if defined(__STDC__)
#pragma warn -nak
#endif

#include  <complex.h>
#include  <math.h>
//--------------------------------------
// 
template  <class T>
class  Vec2 { 
public:
  // constructors

  Vec2(T p, T q) { x = p;  y = q;  }
  Vec2() {  x = y = 0;  }

  //Ŀ
  friend T power(Vec2<T>  &v) { return  (v.x*v.x + v.y*v.y); }
  //밪
  friend T abs(Vec2<T>  &v) { return  sqrt(v.x*v.x + v.y*v.y); }
  T operator~() { return  sqrt(x*x + y*y); }

  // Binary Operator Functions
  friend  Vec2<T> operator+(Vec2<T> &p, Vec2<T> &q)
     { return Vec2<T>(p.x+q.x, p.y+q.y); }

  friend  Vec2<T> operator-(Vec2<T> &p, Vec2<T> &q)
   { return Vec2<T>(p.x-q.x, p.y-q.y); }

//  friend Vec2<T> operator*(Vec2<T>  &p, Vec2<T>  &q)  //Į 
//    { return  Vec2<T>(p.x*q.x, p.y*q.y); }
  friend  T operator*(Vec2<T>  &p, Vec2<T>  &q)  //Į 
    { return  (p.x*q.x + p.y*q.y); }

  friend Vec2<T> operator*(Vec2<T> &p, T x)   //Į 
     { return Vec2<T>(p.x*x, p.y*x);}
  friend Vec2<T> operator*(T x, Vec2<T> &p)
    { return Vec2<T>(p.x*x, p.y*x);}

  friend Vec2<T> operator/(Vec2<T> &p, T x)   //Į 
    { return Vec2<T>(p.x/x, p.y/x);}

  int operator==(Vec2<T> &p) { return p.x==x && p.y==y; }
  int operator!=(Vec2<T> &p)  { return p.x!=x || p.y!=y; }

  // ڽſ  ۷Ʈ
  Vec2<T> &operator+=(Vec2<T> &z) { x+=z.x; y+=z.y; return *this; }
  Vec2<T> &operator-=(Vec2<T> &z) { x-=z.x; y-=z.y; return *this; }
  Vec2<T> &operator*=(T v)  { x *= v;  y*=v;  return *this; }
  Vec2<T> &operator/=(T v)  { x /= v;  y/=v;  return *this; }

  Vec2<T> operator+() { return *this; }
  Vec2<T> operator-() { return Vec2<T>(-x, -y);  }

  friend  ostream &operator<<(ostream &s, Vec2<T> &p)
    { s << '[' << p.x << ', ' << p.y << ']'; return  s;  }
  //data
  T x, y;
};
//--------------------------------------
//--------------------------------------
//3 
//Ͱ     ()  
template  <class T>
class  Vec3 {
  public:
  // constructors
  Vec3(T p, T q, T r) { x=p;  y=q;  z=r;  }
  Vec3() {  x=y=z=0;  }

  //밪
  friend  T abs(Vec3<T>  &v) {  return  sqrt(v.x*v.x + v.y*v.y + v.z*v.z); }
  T operator~() { return  sqrt(x*x + y*y + z*z); }

  // Binary Operator Functions
  friend  Vec3<T> operator+(Vec3<T> &p, Vec3<T> &q)
     { return Vec3<T>(p.x+q.x, p.y+q.y,  p.z+q.z); }

  friend  Vec3<T> operator-(Vec3<T> &p, Vec3<T> &q)
   { return Vec3<T>(p.x-q.x, p.y-q.y,  p.z-q.z); }

//  friend Vec3<T> operator*(Vec3<T>  &p, Vec3<T>  &q)  //Į 
//    { return  Vec3<T>(p.x*q.x, p.y*q.y, p.z*q.z); }
  friend  T operator*(Vec3<T>  &p, Vec3<T>  &q)  //Į 
    { return  (p.x*q.x + p.y*q.y + p.z*q.z); }

  friend Vec3<T> operator^(Vec3<T>  &p, Vec3<T>  &q)  // 
    { return  Vec3<T>(p.y*q.z-p.z*q.y, p.z*q.x-p.x*q.z, p.x*q.y-p.y*q.x); }


  friend Vec3<T> operator*(Vec3<T> &p, T x)     //Į 
   { return Vec3<T>(p.x*x, p.y*x,  p.z*x); }
  friend Vec3<T> operator*(T x, Vec3<T> &p)
    { return Vec3<T>(p.x*x, p.y*x,  p.z*x); }

  friend Vec3<T> operator/(Vec3<T> &p, T x)   //Į 
    { return Vec3<T>(p.x/x, p.y/x,  p.z/x); }

  int operator==(Vec3<T> &p)  { return p.x==x && p.y==y && p.z==z; }
  int operator!=(Vec3<T> &p)  { return p.x!=x || p.y!=y || p.z!=z; }

  //ߪ뫪ګ죭
  Vec3<T> &operator+=(Vec3<T> &a) { x+=a.x; y+=a.y; z+=a.z; return *this; }
  Vec3<T> &operator-=(Vec3<T> &a) { x-=a.x; y-=a.y; z-=a.z; return *this; }
  Vec3<T> &operator*=(T v)  { x*=v;  y*=v;  z*=v; return *this; }
  Vec3<T> &operator/=(T v)  { x/=v;  y/=v;  z/=v; return *this; }

  Vec3<T> operator+() { return *this; }
  Vec3<T> operator-() { return Vec3<T>(-x, -y,  -z);  }

  Vec3<T>& operator=(const  Vec3<double> &src) {
    x=src.x;  y=src.y;  z=src.z;    return *this; }
  Vec3<T>& operator=(const  Vec3<int> &src) {
    x=src.x;  y=src.y;  z=src.z;    return *this; }

  friend  ostream &operator<<(ostream &s, Vec3<T> &p)
    { s << '[' << p.x << ", " << p.y << ", " << p.z << ']'; return  s;  }

  //data
  T x, y, z;
  
};
//--------------------------------------
// 
template  <class T> class VecN {
public:
  int vn; //Ҽ
  T  *vp; // Ϳ 

  // constructors
  VecN()  { vp=0; vn=0; }
  ~VecN() { DeleteVecN(); }
  VecN(VecN<T> &v);  //  ʱȭѴ
  VecN(int n, T *p);   //  ʱȭѴ
  VecN(int n, T d);    //μ ʱȭѴ
  VecN(int n) { vp = new T [vn = n]; }  //ʱȭ , ͸ Ȯ 

  //Լ
  void  DeleteVecN(void) { if(vp!=0) delete [] vp; vp=0;};
  // 
  void  SetDimN(int  n) { DeleteVecN();  vp = new T  [vn = n];  }

  int Dim(void) { return  vn; };                     //(Ҽ) ش
  friend  int GetDim(VecN<T> &p) { return p.vn;  }   //(Ҽ) ش
  friend  T abs(VecN<T> &v);    //밪

  //
  //Կڴ Ŭ  1 īϹǷ  
  //īϴ  ڱ δ  ʿ䰡 ִ
  VecN<T>& operator=(VecN<T> &src);

  friend VecN<T> operator+(VecN<T> &p, VecN<T> &q);
  friend VecN<T> operator-(VecN<T> &p, VecN<T> &q);
  friend VecN<T> operator*(VecN<T>  &p, VecN<T>  &q);
  friend VecN<T> operator*(VecN<T> &p, T a);
  friend VecN<T> operator*(T a, VecN<T> &p);

  friend VecN<T> operator/(VecN<T> &p, T a);
  friend int operator==(VecN<T> &p, VecN<T> &q);
  friend int operator!=(VecN<T> &p, VecN<T> &q);

  T& operator[](int n)  { return  (*this).vp[n];  }

  VecN<T> &operator+=(VecN<T> &z);
  VecN<T> &operator-=(VecN<T> &z);
  VecN<T> &operator*=(T v);
  VecN<T> &operator/=(T v);

  VecN<T> operator+() { return *this; }   //ȣ
  VecN<T> operator-();                    //ȣ

  VecN<T>& operator=(const  VecN<double> &src);
 
  friend  ostream &operator<<(ostream &s, VecN<T> &p);

};


//--------------------------------------
//VecMtx n m  VecN  
template  <class T>
class  VecMtx  //: public  VecN<T>
{
  private:
  int Colum, Row;
  VecN<T> *vp;

  public:
  // constructors
  VecMtx(int colum,  int  row);
  VecMtx(VecMtx &);
  ~VecMtx();

  int ColumN(void) { return Colum;  } //
  int RowN(void) { return Row;  }     //

  void  SolveC1(void);  // 밢 1 ϰ,  1 Ѵ
                                  //(*this).vp[n];
  VecN<T>& operator[](int n)  { return  (*this).vp[n];  }
  friend  ostream &operator<<(ostream &s, VecMtx<T> &p);

};
//--------------------------------------
//======================================
//--------------------------------------
//======================================
//ԼǸ  Ϸ ϴ 쿡 ̺  ܺη 
#pragma option  -Jgd  // ϳ øƮ  ۷ι 
typedef Vec2<int> fake_Vec2_int;
typedef Vec3<int> fake_Vec3_int;
typedef VecN<int> fake_VecN_int;
typedef VecMtx<int> fake_VecMtx_int;

typedef Vec2<double> fake_Vec2_double;
typedef Vec3<double> fake_Vec3_double;
typedef VecN<double> fake_VecN_double;
typedef VecMtx<double> fake_VecMtx_double;

typedef Vec2<complex> fake_Vec2_complex;
typedef Vec3<complex> fake_Vec3_complex;
typedef VecN<complex> fake_VecN_complex;
typedef VecMtx<complex> fake_VecMtx_complex;
//#pragma option  -Jgx  // ؼ Ϸκ ܺ Ѵ
//======================================
//--------------------------------------
//----------------------------------
//
//ǥ
class   Spherical
{
  public:
  double  r;    //
  double  phi;  //أٸ鳻࿡    ȸ 
  double  theta;//κ 簢
  Spherical() { r = phi = theta = 0.0;  }
  Spherical(double  rr, double pp=0.0, double  tt = 0.0) {
    r = rr;   phi = pp;  theta = tt;
  }
};
//----------------------------------
#endif  // __VECTORN_H

